from setuptools import setup


def readme():
    with open('README.md') as f:
        return f.read()


setup(name='PySysC',
    version='0.1',
    description='Python SystemC binding',
    long_description=readme(),
    classifiers=[
        'Development Status :: 3 - Alpha',
        'License :: OSI Approved :: Apache 2.0 License',
        'Programming Language :: Python :: 3.6',
        'Topic :: Engineering :: Simulation'
    ],
    keywords='SystemC simulation',
    url='https://git.minres.com/SystemC/PySysC',
    author='MINRES Technologies GmbH',
    author_email='info@minres.com',
    license='Apache-2.0',
    packages=['pysysc'],
    install_requires=[
        'cppyy',
        'conan'
        ],
    include_package_data=True,
    test_suite='nose.collector',
    tests_require=['nose'],
)
